
#include "dist.h"

// Dataset type

enum Datasettype { Grid1dim, Grid2dim, Grid3dim } ;

class Nodeset ;

class Dataset {
private:
    char * name ;
    Datasettype type ;
    long totalsize ;
    int bytesperunit ;
    int floatsperunit ;
    int operations ;
    Dataset* next ;
public:
    Dataset():name(0), next(0) {} ;
    Dataset(char *name, Datasettype Type, int size, int bytes, int floats, 
		int opers) ;
    ~Dataset() ;
    void append(Dataset * data) ;
    Dataset* locate(char * name) ;
    void display() ;
    long getbytes() ;
    long getoperations() ;
    float update(Nodeset & nodeset, char * name) ;
    float transmit(Nodeset & nodeset, char * begin, char* end) ;
    float datamove(Nodeset & nodeset, char * begin, char* end) ;
    void distribute( Distype distype, int procs_num ) ;
} ;


/*
// distribution object structure

enum DistTpye { Block1dim, Block2dim, Block3dim } ;

class Distribution {
private: 
    char * name ;
    DistTpye type ;
} ;
*/
